highp float time = (TIME * 6.0) / 1200.0 + 4.0;
vec3 sunPosition = vec3(-sin(time), vec2(cos(time)));
vec3 moonPosition = -sunPosition;
vec3 lightPosition = mix(sunPosition, moonPosition, float(sunPosition.y < 0.0));
vec3 upPosition = vec3(0.0,1.0,0.0);
sunVector = normalize(sunPosition);
moonVector = normalize(moonPosition);
lightVector = normalize(lightPosition);
upVector = normalize(upPosition);
isWetness = 0.0;
isMie = mix(0.1,0.6,isWetness);
isDensity = 0.14;
isSun = -smin(-0.01,-sunVector.y*0.5, 0.07);
isEnergyloss = pow(saturate(exp(sunVector.y*5.0)),5.0);
isTwilight = 0.005/(0.01+saturate(sunVector.y));
isTransmission = exp(isSun/-1e-6)-1.0;
isRadialDistributionF = max(-sunVector.y+0.01,0.0)*4.0;
isMultipleScattering = exp(200.0*smin(0.0,sunVector.y,0.03));
isBlueTwilight = pow(rayleigh,vec3(isTwilight));
isRpM = rayleigh + isMie;
vec3 sunlight = sunLight(sunVector,1.0);
sunlight *= 20.0;
vec3 moonlight = sunLight(moonVector,1.0);
moonlight *= 0.1;
colorSunlight = sunlight + moonlight;
colorSunlight *= mix(1.0, 0.25, isWetness);
colorSkylight = Atmosphere(normalize(vec3(0.0,1.0,-0.25)), sunVector, 1.0) * 3.07692308;
colorTorchlight = ColorTemperatureToRGB(2200.0)*4.0;