//https://iquilezles.org/www/articles/smin/smin.htm
highp float smin(in highp float a, in highp float b, in highp float k){
highp float h = saturate(0.5+0.5*(b-a)/k);
return mix(b, a, h) - (1.0-h)*h*k;}
highp float MiePhases(highp float ldv, float g){
return ((1.0+ldv*ldv)*(1.0-g*g)*1.5)/((2.0+g*g)*(1.0+g*g-2.0*g*ldv)*sqrt(1.0+g*g-2.0*g*ldv));}
const float PI = 3.14159265359;
vec3 rayleigh = pow(vec3(0.3,0.5,1.0),vec3(1.3333));
vec3 Atmosphere(highp vec3 View, highp vec3 Sun, highp float x){
highp float Mie = max(dot(View, Sun),0.0);
highp float ScatterMie = MiePhases(Mie,mix(0.9,0.4,isWetness)) * 0.3 + MiePhases(Mie,mix(0.6,0.1,isWetness)) * 0.7;
highp float RayleighMie = MiePhases(Mie,0.0);
highp float HeightWFEarthShadow = sign(View.y*1.)*pow(abs(View.y*1.),saturate(0.5*-Mie+0.5)*0.005/isSun+1.0);
highp float Transmission = HeightWFEarthShadow*isTransmission+isSun;
highp float RadialDistributionF = 0.5-isRadialDistributionF*(0.5*-Mie+0.5);
vec3 absorb = -(isSun * exp(((isDensity * isRpM) * ((Transmission * exp(40.0*x * -HeightWFEarthShadow)) / isSun - 1.0)) / HeightWFEarthShadow)) / (isRpM * Transmission) + ((isSun * exp(((isDensity * isRpM) * (Transmission / isSun - 1.0)) / HeightWFEarthShadow)) / (isRpM * Transmission));
vec3 MultipleScattering = (1.0 / isRpM - 1.0 / (exp(((-1.0 + exp(HeightWFEarthShadow * 40.0*x * RadialDistributionF)) * isRpM * isDensity) / (exp(RadialDistributionF * 40.0*x * HeightWFEarthShadow) * (RadialDistributionF * HeightWFEarthShadow))) * isRpM)) * 0.05;
return 6.5 * (isEnergyloss * (absorb * isMie * ScatterMie + absorb * rayleigh * RayleighMie) * isBlueTwilight + (MultipleScattering * rayleigh * isEnergyloss));}
vec3 sunLight(highp vec3 s, highp float x){
return max(saturate(0.5*s.y*80.0)*exp(-(rayleigh+0.5*isWetness)*(isDensity/(0.5*s.y)-isDensity/(exp(s.y*40.0*x*2.0)*(0.5*s.y)))),0.0);
}